VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIFileOperation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 12/2018

Option Explicit

' ----==== Const ====----
Private Const CLSID_FileOperation As String = "{3ad05575-8857-4850-9277-11b85bdb8e09}"
Private Const IID_IFileOperation As String = "{947aab5f-0a5c-4c13-b4d6-4bf7836fc9f8}"
    
' ----==== Enums ====----
Private Enum E_vtbOffsets
    '/*** IUnknown methods ***/
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    '/*** IFileOperation methods ***/
    vtb_Advise
    vtb_Unadvise
    vtb_SetOperationFlags
    vtb_SetProgressMessage
    vtb_SetProgressDialog
    vtb_SetProperties
    vtb_SetOwnerWindow
    vtb_ApplyPropertiesToItem
    vtb_ApplyPropertiesToItems
    vtb_RenameItem
    vtb_RenameItems
    vtb_MoveItem
    vtb_MoveItems
    vtb_CopyItem
    vtb_CopyItems
    vtb_DeleteItem
    vtb_DeleteItems
    vtb_NewItem
    vtb_PerformOperations
    vtb_GetAnyOperationAborted
End Enum

' ----==== Variablen ====----
Private m_Interface As InterfaceData

' ----==== Interface IFileOperation Func ====----
Public Function Advise(ByVal pfops As Long) As Long

    Dim lRet As Long
    Dim pdwCookie As Long
    Dim ppdwCookie As Long
    
    ppdwCookie = VarPtr(pdwCookie)

    If x_OleInvoke(vtb_Advise, pfops, ppdwCookie) Then

        lRet = pdwCookie

    End If

    Advise = lRet

End Function

Public Function Unadvise(ByVal dwCookie As Long) As Boolean

    Dim bRet As Boolean
    
    bRet = False

    If x_OleInvoke(vtb_Unadvise, dwCookie) Then

        bRet = True

    End If

    Unadvise = bRet

End Function

Public Function SetOperationFlags(ByVal dwOperationFlags As FileOperationFlags) As Boolean
    
    Dim bRet As Boolean
    
    bRet = False

    If x_OleInvoke(vtb_SetOperationFlags, dwOperationFlags) Then

        bRet = True

    End If

    SetOperationFlags = bRet

End Function

' This method is not implemented.
Public Function SetProgressMessage(ByVal pszMessage As String) As Boolean
    
    Dim bRet As Boolean
    Dim ppszMessage As Long
    
    bRet = False
    ppszMessage = StrPtr(pszMessage)

    If x_OleInvoke(vtb_SetProgressMessage, ppszMessage) Then

        bRet = True

    End If

    SetProgressMessage = bRet
    
End Function

Public Function SetProgressDialog(ByVal popd As Long) As Boolean

    Dim bRet As Boolean
    
    bRet = False

    If x_OleInvoke(vtb_SetProgressDialog, popd) Then

        bRet = True

    End If

    SetProgressDialog = bRet

End Function

Public Function SetProperties(ByVal pproparray As Long) As Boolean

    Dim bRet As Boolean
    
    bRet = False

    If x_OleInvoke(vtb_SetProperties, pproparray) Then

        bRet = True

    End If

    SetProperties = bRet

End Function

Public Function SetOwnerWindow(ByVal hwndOwner As Long) As Boolean
    
    Dim bRet As Boolean
    
    bRet = False

    If x_OleInvoke(vtb_SetOwnerWindow, hwndOwner) Then

        bRet = True

    End If

    SetOwnerWindow = bRet

End Function

Public Function ApplyPropertiesToItem(ByVal psiItem As Long) As Boolean

    Dim bRet As Boolean
    
    bRet = False

    If x_OleInvoke(vtb_ApplyPropertiesToItem, psiItem) Then

        bRet = True

    End If

    ApplyPropertiesToItem = bRet

End Function

Public Function ApplyPropertiesToItems(ByVal punkItems As Long) As Boolean

    Dim bRet As Boolean
    
    bRet = False

    If x_OleInvoke(vtb_ApplyPropertiesToItems, punkItems) Then

        bRet = True

    End If

    ApplyPropertiesToItems = bRet

End Function

Public Function RenameItem(ByVal psiItem As Long, ByVal pszNewName As String, _
    ByVal pfopsItem As Long) As Boolean

    Dim bRet As Boolean
    Dim ppszNewName As Long

    bRet = False
    ppszNewName = StrPtr(pszNewName)

    If x_OleInvoke(vtb_RenameItem, psiItem, ppszNewName, pfopsItem) Then

        bRet = True

    End If

    RenameItem = bRet

End Function

Public Function RenameItems(ByVal punkItems As Long, ByVal pszNewName As String) As Boolean

    Dim bRet As Boolean
    Dim ppszNewName As Long

    bRet = False
    ppszNewName = StrPtr(pszNewName)

    If x_OleInvoke(vtb_RenameItems, punkItems, ppszNewName) Then

        bRet = True

    End If

    RenameItems = bRet

End Function

Public Function MoveItem(ByVal psiItem As Long, ByVal psiDestinationFolder As _
    Long, ByVal pszNewName As String, ByVal pfopsItem As Long) As Boolean

    Dim bRet As Boolean
    Dim ppszNewName As Long

    bRet = False
    ppszNewName = StrPtr(pszNewName)

    If x_OleInvoke(vtb_MoveItem, psiItem, psiDestinationFolder, ppszNewName, _
        pfopsItem) Then

        bRet = True

    End If

    MoveItem = bRet

End Function

Public Function MoveItems(ByVal punkItems As Long, ByVal psiDestinationFolder As _
    Long) As Boolean

    Dim bRet As Boolean

    If x_OleInvoke(vtb_MoveItems, punkItems, psiDestinationFolder) Then

        bRet = True

    End If

    MoveItems = bRet

End Function

Public Function CopyItem(ByVal psiItem As Long, ByVal psiDestinationFolder As _
    Long, ByVal pszCopyName As String, ByVal pfopsItem As Long) As Boolean

    Dim bRet As Boolean
    Dim ppszCopyName As Long

    bRet = False
    ppszCopyName = StrPtr(pszCopyName)

    If x_OleInvoke(vtb_CopyItem, psiItem, psiDestinationFolder, ppszCopyName, _
        pfopsItem) Then

        bRet = True

    End If

    CopyItem = bRet

End Function

Public Function CopyItems(ByVal punkItems As Long, ByVal psiDestinationFolder As _
    Long) As Boolean

    Dim bRet As Boolean

    If x_OleInvoke(vtb_CopyItems, punkItems, psiDestinationFolder) Then

        bRet = True

    End If

    CopyItems = bRet

End Function

Public Function DeleteItem(ByVal psiItem As Long, ByVal pfopsItem As Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_DeleteItem, psiItem, pfopsItem) Then

        bRet = True

    End If

    DeleteItem = bRet

End Function

Public Function DeleteItems(ByVal punkItems As Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_DeleteItems, punkItems) Then

        bRet = True

    End If

    DeleteItems = bRet

End Function

Public Function NewItem(ByVal psiDestinationFolder As Long, ByVal dwFileAttributes _
    As FileAttributes, ByVal pszName As String, ByVal pszTemplateName As String, _
    ByVal pfopsItem As Long) As Boolean

    Dim bRet As Boolean
    Dim ppszName As Long
    Dim ppszTemplateName As Long

    ppszName = StrPtr(pszName)
    ppszTemplateName = StrPtr(pszTemplateName)

    bRet = False

    If x_OleInvoke(vtb_NewItem, psiDestinationFolder, dwFileAttributes, ppszName, _
        ppszTemplateName, pfopsItem) Then

        bRet = True

    End If

    NewItem = bRet

End Function

Public Function PerformOperations() As Boolean
    
    Dim bRet As Boolean
    
    bRet = False

    If x_OleInvoke(vtb_PerformOperations) Then

        bRet = True

    End If

    PerformOperations = bRet

End Function

Public Function GetAnyOperationAborted() As Boolean
    
    Dim bRet As Boolean
    Dim pbRet As Long
    Dim ppbRet As Long
    
    ppbRet = VarPtr(pbRet)

    If x_OleInvoke(vtb_GetAnyOperationAborted, ppbRet) Then

        bRet = CBool(pbRet)

    End If

    GetAnyOperationAborted = bRet

End Function

' ----==== Interface Helper Func ====----
'
' Initialisiert das Interfaces aus CLSID und IID
Private Sub Class_Initialize()

    m_Interface.pObject = ObjPtr(Me)
    m_Interface.boolRaiseErrors = False

    Call InitInterface(m_Interface, CLSID_FileOperation, IID_IFileOperation)

End Sub

' Ruft Release des Interfaces auf
Private Sub Class_Terminate()

    Call ReleaseInterface(m_Interface)

End Sub

' Fhrt die Funktion des Interfaces aus
Private Function x_OleInvoke(ByVal vtb As E_vtbOffsets, ParamArray var()) As Boolean

    ' ist ein Pointer auf ein Interface vorhanden
    If m_Interface.pInterface <> 0& Then

        ' Funktion ausfhren
        x_OleInvoke = OleInvoke(m_Interface, vtb, var)

    End If

End Function

' wird aus der modInterface bei einem Fehler aufgerufen
Public Sub x_RaiseError(ByVal lngErrCode As Long, ByVal strErrText As String)

    Call Err.Raise(lngErrCode, App.EXEName & "\" & TypeName(Me), strErrText)

End Sub

' Fehler auslsen? Standard = False
Public Property Let RaiseErrors(ByVal Raise As Boolean)

    m_Interface.boolRaiseErrors = Raise

End Property

' liefert den Pointer auf das Interface zurck
Public Property Get IfcPtr() As Long

    IfcPtr = m_Interface.pInterface

End Property


