VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIFileOperationProgressSink"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 12/2018

Option Explicit

' ----==== Events Interface1Events ====----
Public Event StartOperations()

Public Event FinishOperations(ByVal hrResult As Long)

Public Event PreRenameItem(ByVal dwFlags As TRANSFER_SOURCE_FLAGS, ByVal psiItem _
    As Long, ByVal pszNewName As Long)

Public Event PostRenameItem(ByVal dwFlags As TRANSFER_SOURCE_FLAGS, ByVal psiItem _
    As Long, ByVal pszNewName As Long, ByVal hrRename As Long, ByVal _
    psiNewlyCreated As Long)

Public Event PreMoveItem(ByVal dwFlags As TRANSFER_SOURCE_FLAGS, ByVal psiItem As _
    Long, ByVal psiDestinationFolder As Long, ByVal pszNewName As Long)

Public Event PostMoveItem(ByVal dwFlags As TRANSFER_SOURCE_FLAGS, ByVal psiItem As _
    Long, ByVal psiDestinationFolder As Long, ByVal pszNewName As Long, ByVal _
    hrMove As Long, ByVal psiNewlyCreated As Long)

Public Event PreCopyItem(ByVal dwFlags As TRANSFER_SOURCE_FLAGS, ByVal psiItem As _
    Long, ByVal psiDestinationFolder As Long, ByVal pszNewName As Long)

Public Event PostCopyItem(ByVal dwFlags As TRANSFER_SOURCE_FLAGS, ByVal psiItem As _
    Long, ByVal psiDestinationFolder As Long, ByVal pszNewName As Long, ByVal _
    hrCopy As Long, ByVal psiNewlyCreated As Long)

Public Event PreDeleteItem(ByVal dwFlags As TRANSFER_SOURCE_FLAGS, ByVal psiItem _
    As Long)

Public Event PostDeleteItem(ByVal dwFlags As TRANSFER_SOURCE_FLAGS, ByVal psiItem _
    As Long, ByVal hrDelete As Long, ByVal psiNewlyCreated As Long)

Public Event PreNewItem(ByVal dwFlags As TRANSFER_SOURCE_FLAGS, ByVal _
    psiDestinationFolder As Long, ByVal pszNewName As Long)

Public Event PostNewItem(ByVal dwFlags As TRANSFER_SOURCE_FLAGS, ByVal _
    psiDestinationFolder As Long, ByVal pszNewName As Long, ByVal pszTemplateName _
    As Long, ByVal dwFileAttributes As Long, ByVal hrNew As Long, ByVal psiNewItem _
    As Long)

Public Event UpdateProgress(ByVal iWorkTotal As Long, ByVal iWorkSoFar As Long)

Public Event ResetTimer()

Public Event PauseTimer()

Public Event ResumeTimer()

' ----==== Variablen ====----
Private pInterfaceEvents As Long

Private Sub Class_Initialize()

    ' Interface InterfaceEvents initialisieren
    pInterfaceEvents = modIFileOperationProgressSink.IFileOperationProgressSink(ObjPtr(Me))

End Sub

Private Sub Class_Terminate()
    
    ' ist ein Pointer auf das Interface vorhanden
    If pInterfaceEvents <> 0 Then
    
        ' ruft Release des Interfaces auf
        Call CoTaskMemFree(pInterfaceEvents)
    
    End If
    
End Sub

' ----==== liefert den Pointer auf InterfaceEvents zurck ====----
Public Function IfcPtr() As Long

    IfcPtr = pInterfaceEvents

End Function

' ----==== Raise Events Interface1Events ====----
Public Sub StartOperations()

    RaiseEvent StartOperations

End Sub

Public Sub FinishOperations(ByVal hrResult As Long)

    RaiseEvent FinishOperations(hrResult)

End Sub

Public Sub PreRenameItem(ByVal dwFlags As TRANSFER_SOURCE_FLAGS, ByVal psiItem As _
    Long, ByVal pszNewName As Long)

    RaiseEvent PreRenameItem(dwFlags, psiItem, pszNewName)

End Sub

Public Sub PostRenameItem(ByVal dwFlags As TRANSFER_SOURCE_FLAGS, ByVal psiItem As _
    Long, ByVal pszNewName As Long, ByVal hrRename As Long, ByVal psiNewlyCreated _
    As Long)

    RaiseEvent PostRenameItem(dwFlags, psiItem, pszNewName, hrRename, _
        psiNewlyCreated)

End Sub

Public Sub PreMoveItem(ByVal dwFlags As TRANSFER_SOURCE_FLAGS, ByVal psiItem As _
    Long, ByVal psiDestinationFolder As Long, ByVal pszNewName As Long)

    RaiseEvent PreMoveItem(dwFlags, psiItem, psiDestinationFolder, pszNewName)

End Sub

Public Sub PostMoveItem(ByVal dwFlags As TRANSFER_SOURCE_FLAGS, ByVal psiItem As _
    Long, ByVal psiDestinationFolder As Long, ByVal pszNewName As Long, ByVal _
    hrMove As Long, ByVal psiNewlyCreated As Long)

    RaiseEvent PostMoveItem(dwFlags, psiItem, psiDestinationFolder, pszNewName, _
        hrMove, psiNewlyCreated)

End Sub

Public Sub PreCopyItem(ByVal dwFlags As TRANSFER_SOURCE_FLAGS, ByVal psiItem As _
    Long, ByVal psiDestinationFolder As Long, ByVal pszNewName As Long)

    RaiseEvent PreCopyItem(dwFlags, psiItem, psiDestinationFolder, pszNewName)

End Sub

Public Sub PostCopyItem(ByVal dwFlags As TRANSFER_SOURCE_FLAGS, ByVal psiItem As _
    Long, ByVal psiDestinationFolder As Long, ByVal pszNewName As Long, ByVal _
    hrCopy As Long, ByVal psiNewlyCreated As Long)

    RaiseEvent PostCopyItem(dwFlags, psiItem, psiDestinationFolder, pszNewName, _
        hrCopy, psiNewlyCreated)

End Sub

Public Sub PreDeleteItem(ByVal dwFlags As TRANSFER_SOURCE_FLAGS, ByVal psiItem As _
    Long)

    RaiseEvent PreDeleteItem(dwFlags, psiItem)

End Sub

Public Sub PostDeleteItem(ByVal dwFlags As TRANSFER_SOURCE_FLAGS, ByVal psiItem As _
    Long, ByVal hrDelete As Long, ByVal psiNewlyCreated As Long)

    RaiseEvent PostDeleteItem(dwFlags, psiItem, hrDelete, psiNewlyCreated)

End Sub

Public Sub PreNewItem(ByVal dwFlags As TRANSFER_SOURCE_FLAGS, ByVal _
    psiDestinationFolder As Long, ByVal pszNewName As Long)

    RaiseEvent PreNewItem(dwFlags, psiDestinationFolder, pszNewName)

End Sub

Public Sub PostNewItem(ByVal dwFlags As TRANSFER_SOURCE_FLAGS, ByVal _
    psiDestinationFolder As Long, ByVal pszNewName As Long, ByVal pszTemplateName _
    As Long, ByVal dwFileAttributes As Long, ByVal hrNew As Long, ByVal psiNewItem _
    As Long)

    RaiseEvent PostNewItem(dwFlags, psiDestinationFolder, pszNewName, _
        pszTemplateName, dwFileAttributes, hrNew, psiNewItem)

End Sub

Public Sub UpdateProgress(ByVal iWorkTotal As Long, ByVal iWorkSoFar As Long)

    RaiseEvent UpdateProgress(iWorkTotal, iWorkSoFar)

End Sub

Public Sub ResetTimer()

    RaiseEvent ResetTimer

End Sub

Public Sub PauseTimer()

    RaiseEvent PauseTimer

End Sub

Public Sub ResumeTimer()

    RaiseEvent ResumeTimer

End Sub


