VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIOperationsProgressDialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 12/2018

Option Explicit

' ----==== Const ====----
Private Const S_OK As Long = &H0&
Private Const CLSID_ProgressDialog As String = "{F8383852-FCD3-11d1-A6B9-006097DF5BD4}"
Private Const IID_IOperationsProgressDialog As String = "{0C9FB851-E5C9-43EB-A370-F0677B13874C}"

' ----==== Enums ====----
Private Enum E_vtbOffsets
    '/*** IUnknown methods ***/
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    '/*** IOperationsProgressDialog methods ***/
    vtb_StartProgressDialog
    vtb_StopProgressDialog
    vtb_SetOperation
    vtb_SetMode
    vtb_UpdateProgress
    vtb_UpdateLocations
    vtb_ResetTimer
    vtb_PauseTimer
    vtb_ResumeTimer
    vtb_GetMilliseconds
    vtb_GetOperationStatus
End Enum

' ----==== Variablen ====----
Private m_Interface As InterfaceData

' ----==== Interface IOperationsProgressDialog Func ====----
Public Function StartProgressDialog(ByVal hwndOwner As Long, Optional ByVal _
    dwFlags As PROGDLG = PROGDLG_NORMAL) As Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_StartProgressDialog, hwndOwner, dwFlags) Then

        bRet = True

    End If

    StartProgressDialog = bRet

End Function

Public Function StopProgressDialog() As Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_StopProgressDialog) Then

        bRet = True

    End If

    StopProgressDialog = bRet

End Function

Public Function SetOperation(Optional ByVal action As SPACTION = SPACTION_NONE) As _
    Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_SetOperation, action) Then

        bRet = True

    End If

    SetOperation = bRet

End Function

Public Function SetMode(Optional ByVal mode As PDMODE = PDM_DEFAULT) As Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_SetMode, mode) Then

        bRet = True

    End If

    SetMode = bRet

End Function

Public Function UpdateProgress(ByVal ullPointsCurrent As Currency, ByVal _
    ullPointsTotal As Currency, ByVal ullSizeCurrent As Currency, ByVal _
    ullSizeTotal As Currency, ByVal ullItemsCurrent As Currency, ByVal _
    ullItemsTotal As Currency) As Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_UpdateProgress, ullPointsCurrent, ullPointsTotal, _
        ullSizeCurrent, ullSizeTotal, ullItemsCurrent, ullItemsTotal) Then

        bRet = True

    End If

    UpdateProgress = bRet

End Function

Public Function UpdateLocations(ByVal psiSource As Long, ByVal psiTarget As Long, _
    ByVal psiItem As Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_UpdateLocations, psiSource, psiTarget, psiItem) Then

        bRet = True

    End If

    UpdateLocations = bRet

End Function

Public Function ResetTimer() As Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_ResetTimer) Then

        bRet = True

    End If

    ResetTimer = bRet

End Function

Public Function PauseTimer() As Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_PauseTimer) Then

        bRet = True

    End If

    PauseTimer = bRet

End Function

Public Function ResumeTimer() As Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_ResumeTimer) Then

        bRet = True

    End If

    ResumeTimer = bRet

End Function

Public Function GetMilliseconds(ByRef pullElapsed As Currency, ByRef pullRemaining As Currency) As Boolean

    Dim bRet As Boolean
    Dim ppullElapsed As Long
    Dim ppullRemaining As Long
        
    bRet = False

    ppullElapsed = VarPtr(pullElapsed)
    ppullRemaining = VarPtr(pullRemaining)

    If x_OleInvoke(vtb_GetMilliseconds, ppullElapsed, ppullRemaining) Then

        bRet = True

    End If

    GetMilliseconds = bRet

End Function

Public Function GetOperationStatus() As PDOPSTATUS

    Dim lRet As Long
    Dim popstatus As Long
    Dim ppopstatus As Long
    
    ppopstatus = VarPtr(popstatus)
    
    If x_OleInvoke(vtb_GetOperationStatus, ppopstatus) Then

        lRet = popstatus

    End If

    GetOperationStatus = lRet

End Function

' ----==== Interface Helper Func ====----
'
' Initialisiert das Interfaces aus CLSID und IID
Private Sub Class_Initialize()

    m_Interface.pObject = ObjPtr(Me)
    m_Interface.boolRaiseErrors = False

    Call InitInterface(m_Interface, CLSID_ProgressDialog, _
        IID_IOperationsProgressDialog)

End Sub

' Ruft Release des Interfaces auf
Private Sub Class_Terminate()

    Call ReleaseInterface(m_Interface)

End Sub

' Fhrt die Funktion des Interfaces aus
Private Function x_OleInvoke(ByVal vtb As E_vtbOffsets, ParamArray var()) As Boolean

    ' ist ein Pointer auf ein Interface vorhanden
    If m_Interface.pInterface <> 0& Then

        ' Funktion ausfhren
        x_OleInvoke = OleInvoke(m_Interface, vtb, var)

    End If

End Function

' wird aus der modInterface bei einem Fehler aufgerufen
Public Sub x_RaiseError(ByVal lngErrCode As Long, ByVal strErrText As String)

    Call Err.Raise(lngErrCode, App.EXEName & "\" & TypeName(Me), strErrText)

End Sub

' Fehler auslsen? Standard = False
Public Property Let RaiseErrors(ByVal Raise As Boolean)

    m_Interface.boolRaiseErrors = Raise

End Property

' liefert den Pointer auf das Interface zurck
Public Property Get IfcPtr() As Long

    IfcPtr = m_Interface.pInterface

End Property

