VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIShellFolder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 12/2018

Option Explicit

' ----==== Const ====----
Private Const CLSID_ShellFolder As String = ""
Private Const IID_IShellFolder As String = "{000214E6-0000-0000-C000-000000000046}"
    
' ----==== Enums ====----
Private Enum E_vtbOffsets
    '/*** IUnknown methods ***/
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    '/*** IShellFolder methods ***/
    vtb_ParseDisplayName
    vtb_EnumObjects
    vtb_BindToObject
    vtb_BindToStorage
    vtb_CompareIDs
    vtb_CreateViewObject
    vtb_GetAttributesOf
    vtb_GetUIObjectOf
    vtb_GetDisplayNameOf
    vtb_SetNameOf
End Enum

' ----==== Variablen ====----
Private m_Interface As InterfaceData

' ----==== Interface IShellFolder Func ====----
Public Function ParseDisplayName(ByVal pszDisplayName As String) As Long

    Dim lRet As Long
    Dim ppszDisplayName As Long
    Dim pchEaten As Long
    Dim ppchEaten As Long
    Dim ppidl As Long
    Dim pppidl As Long
    
    ppszDisplayName = StrPtr(pszDisplayName)
    ppchEaten = VarPtr(pchEaten)
    pppidl = VarPtr(ppidl)
    
    If x_OleInvoke(vtb_ParseDisplayName, 0&, 0&, ppszDisplayName, ppchEaten, pppidl, 0&) Then

        lRet = ppidl

    End If

    ParseDisplayName = lRet
    
End Function

Public Function EnumObjects(ByVal hwndOwner As Long, ByVal grfFlags As Long) As Long

    Dim lRet As Long
    Dim ppenumIDList As Long
    Dim pppenumIDList As Long

    pppenumIDList = VarPtr(ppenumIDList)

    If x_OleInvoke(vtb_EnumObjects, hwndOwner, grfFlags, pppenumIDList) Then

        lRet = ppenumIDList

    End If

    EnumObjects = lRet
    
End Function

Public Function BindToObject(ByVal pidl As Long, ByVal pbc As Long, ByVal riid As Long) As Long

    Dim lRet As Long
    Dim ppvOut As Long
    Dim pppvOut As Long

    pppvOut = VarPtr(ppvOut)

    If x_OleInvoke(vtb_BindToObject, pidl, pbc, riid, pppvOut) Then

        lRet = ppvOut

    End If

    BindToObject = lRet
    
End Function

Public Function BindToStorage(ByVal pidl As Long, ByVal pbc As Long, ByVal riid As Long) As Long

    Dim lRet As Long
    Dim ppvOut As Long
    Dim pppvOut As Long

    pppvOut = VarPtr(ppvOut)

    If x_OleInvoke(vtb_BindToStorage, pidl, pbc, riid, pppvOut) Then

        lRet = ppvOut

    End If

    BindToStorage = lRet
    
End Function

Public Function CompareIDs(ByVal lParam As Long, ByVal pidl1 As Long, ByVal pidl2 As Long) As Long

    Dim bRet As Boolean
    
    If x_OleInvoke(vtb_CompareIDs, lParam, pidl1, pidl2) Then

        bRet = True

    End If

    CompareIDs = bRet

End Function
  
Public Function CreateViewObject(ByVal hwndOwner As Long, ByVal riid As Long) As Long
    
    Dim lRet As Long
    Dim ppv As Long
    Dim pppv As Long
    
    pppv = VarPtr(ppv)
    
    If x_OleInvoke(vtb_CreateViewObject, hwndOwner, riid, pppv) Then

        lRet = ppv

    End If

    CreateViewObject = lRet
    
End Function

Public Function GetAttributesOf(ByVal cidl As Long, ByVal apidl As Long, ByRef rgfInOut As Long) As Boolean
    
    Dim bRet As Boolean
    
    If x_OleInvoke(vtb_GetAttributesOf, cidl, apidl, rgfInOut) Then

        bRet = True

    End If

    GetAttributesOf = bRet
    
End Function

Public Function GetUIObjectOf(ByVal hwndOwner As Long, ByVal cidl As Long, ByVal _
    apidl As Long, ByVal riid As Long) As Long
    
    Dim lRet As Long
    Dim ppv As Long
    Dim pppv As Long
    Dim rgfReserved As Long
    Dim prgfReserved As Long
    
    rgfReserved = 0&
    
    pppv = VarPtr(ppv)
    prgfReserved = VarPtr(rgfReserved)
    
    If x_OleInvoke(vtb_GetUIObjectOf, hwndOwner, cidl, apidl, riid, prgfReserved, pppv) Then
    
        lRet = ppv
        
    End If
    
    GetUIObjectOf = lRet
    
End Function

Public Function GetDisplayNameOf(ByVal pidl As Long, ByVal uFlags As Long) As Long

    Dim lRet As Long
    Dim pName As Long
    Dim ppName As Long
    
    ppName = VarPtr(pName)

    If x_OleInvoke(vtb_GetDisplayNameOf, pidl, uFlags, ppName) Then
    
        lRet = pName
        
    End If

    GetDisplayNameOf = lRet
    
End Function

Public Function SetNameOf(ByVal hwnd As Long, ByVal pidl As Long, ByVal pszName As Long, ByVal uFlags As Long) As Long

    Dim lRet As Long
    Dim pidlOut As Long
    Dim ppidlOut As Long
    
    ppidlOut = VarPtr(pidlOut)

    If x_OleInvoke(vtb_SetNameOf, hwnd, pidl, pszName, uFlags, ppidlOut) Then
    
        lRet = pidlOut
        
    End If

    SetNameOf = lRet
    
End Function

' ----==== Interface Helper Func ====----
'
' Initialisiert das Interface ber einen Interface-Pointer
Public Sub Init(ByVal pInterface As Long)

    If pInterface <> 0& Then

        m_Interface.pObject = ObjPtr(Me)
        m_Interface.boolRaiseErrors = False
        m_Interface.pInterface = pInterface

    End If

End Sub

' Ruft Release des Interfaces auf
Private Sub Class_Terminate()

    Call ReleaseInterface(m_Interface)

End Sub

' Fhrt die Funktion des Interfaces aus
Private Function x_OleInvoke(ByVal vtb As E_vtbOffsets, ParamArray var()) As Boolean

    ' ist ein Pointer auf ein Interface vorhanden
    If m_Interface.pInterface <> 0& Then

        ' Funktion ausfhren
        x_OleInvoke = OleInvoke(m_Interface, vtb, var)

    End If

End Function

' wird aus der modInterface bei einem Fehler aufgerufen
Public Sub x_RaiseError(ByVal lngErrCode As Long, ByVal strErrText As String)

    Call Err.Raise(lngErrCode, App.EXEName & "\" & TypeName(Me), strErrText)

End Sub

' Fehler auslsen? Standard = False
Public Property Let RaiseErrors(ByVal Raise As Boolean)

    m_Interface.boolRaiseErrors = Raise

End Property

' liefert den Pointer auf das Interface zurck
Public Property Get IfcPtr() As Long

    IfcPtr = m_Interface.pInterface

End Property

