VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIShellItemArray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 12/2018

Option Explicit

' ----==== Const ====----
Private Const CLSID_ShellItemArray As String = ""
Private Const IID_IShellItemArray As String = "{B63EA76D-1F85-456F-A19C-48159EFA858B}"

' ----==== Enums ====----
Private Enum E_vtbOffsets
    '/*** IUnknown methods ***/
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    '/*** IShellItemArray methods ***/
    vtb_BindToHandler
    vtb_GetPropertyStore
    vtb_GetPropertyDescriptionList
    vtb_GetAttributes
    vtb_GetCount
    vtb_GetItemAt
    vtb_EnumItems
End Enum

' ----==== Variablen ====----
Private m_Interface As InterfaceData

' ----==== Interface IShellItemArray Func ====----
Public Function BindToHandler(ByVal pbc As Long, ByVal rbhid As Long, ByVal riid _
    As Long) As Long

    Dim pRet As Long
    Dim ppvOut As Long
    Dim pppvOut As Long

    pppvOut = VarPtr(ppvOut)

    If x_OleInvoke(vtb_BindToHandler, pbc, rbhid, riid, pppvOut) Then

        pRet = ppvOut

    End If

    BindToHandler = pRet

End Function

Public Function GetPropertyStore(ByVal flags As GETPROPERTYSTOREFLAGS, ByVal riid As Long) As Long

    Dim pRet As Long
    Dim ppv As Long
    Dim pppv As Long

    pppv = VarPtr(ppv)

    If x_OleInvoke(vtb_GetPropertyStore, flags, riid, pppv) Then

        pRet = ppv

    End If

    GetPropertyStore = pRet

End Function

Friend Function GetPropertyDescriptionList(ByRef keyType As PROPERTYKEY, ByVal riid As Long) As Long

    Dim pRet As Long
    Dim ppv As Long
    Dim pppv As Long
    Dim pkeyType As Long
    
    pppv = VarPtr(ppv)
    pkeyType = VarPtr(keyType)
    
    If x_OleInvoke(vtb_GetPropertyDescriptionList, pkeyType, riid, pppv) Then

        pRet = ppv

    End If

    GetPropertyDescriptionList = pRet

End Function

Public Function GetAttributes(ByVal AttribFlags As SIATTRIBFLAGS, ByVal sfgaoMask As SFGAO) As SFGAO

    Dim lRet As Long
    Dim psfgaoAttribs As Long
    Dim ppsfgaoAttribs As Long

    ppsfgaoAttribs = VarPtr(psfgaoAttribs)

    If x_OleInvoke(vtb_GetAttributes, AttribFlags, sfgaoMask, ppsfgaoAttribs) Then

        lRet = psfgaoAttribs

    End If

    GetAttributes = lRet

End Function

Public Function GetCount() As Long

    Dim lRet As Long
    Dim pdwNumItems As Long
    Dim ppdwNumItems As Long

    ppdwNumItems = VarPtr(pdwNumItems)

    If x_OleInvoke(vtb_GetCount, ppdwNumItems) Then

        lRet = pdwNumItems

    End If

    GetCount = lRet

End Function

Public Function GetItemAt(ByVal dwIndex As Long) As Long

    Dim pRet As Long
    Dim ppsi As Long
    Dim pppsi As Long

    pppsi = VarPtr(ppsi)

    If x_OleInvoke(vtb_GetItemAt, dwIndex, pppsi) Then

        pRet = ppsi

    End If

    GetItemAt = pRet

End Function

Public Function EnumItems() As Long

    Dim pRet As Long
    Dim ppenumShellItems As Long
    Dim pppenumShellItems As Long

    pppenumShellItems = VarPtr(ppenumShellItems)

    If x_OleInvoke(vtb_EnumItems, pppenumShellItems) Then

        pRet = ppenumShellItems

    End If

    EnumItems = pRet

End Function

' ----==== Interface Helper Func ====----
'
' Initialisiert das Interface ber einen Interface-Pointer
Public Sub Init(ByVal pInterface As Long)

    If pInterface <> 0& Then

        m_Interface.pObject = ObjPtr(Me)
        m_Interface.boolRaiseErrors = False
        m_Interface.pInterface = pInterface

    End If

End Sub

' Ruft Release des Interfaces auf
Private Sub Class_Terminate()

    Call ReleaseInterface(m_Interface)

End Sub

' Fhrt die Funktion des Interfaces aus
Private Function x_OleInvoke(ByVal vtb As E_vtbOffsets, ParamArray var()) As Boolean

    ' ist ein Pointer auf ein Interface vorhanden
    If m_Interface.pInterface <> 0& Then

        ' Funktion ausfhren
        x_OleInvoke = OleInvoke(m_Interface, vtb, var)

    End If

End Function

' wird aus der modInterface bei einem Fehler aufgerufen
Public Sub x_RaiseError(ByVal lngErrCode As Long, ByVal strErrText As String)

    Call Err.Raise(lngErrCode, App.EXEName & "\" & TypeName(Me), strErrText)

End Sub

' Fehler auslsen? Standard = False
Public Property Let RaiseErrors(ByVal Raise As Boolean)

    m_Interface.boolRaiseErrors = Raise

End Property

' liefert den Pointer auf das Interface zurck
Public Property Get IfcPtr() As Long

    IfcPtr = m_Interface.pInterface

End Property

