VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsRetIShellItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 12/2018

' Kein ReleaseInterface fr die Rckgabe von IFileOperationProgressSink -> IShellItem !!!

Option Explicit

' ----==== Const ====----
Private Const CLSID_ShellItem As String = "{9ac9fbe1-e0a2-4ad6-b4ee-e212013ea917}"
Private Const IID_IShellItem As String = "{43826d1e-e718-42ee-bc55-a1e261c37bfe}"

' ----==== Enums ====----
Private Enum E_vtbOffsets
    '/*** IUnknown methods ***/
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    '/*** IShellItem methods ***/
    vtb_BindToHandler
    vtb_GetParent
    vtb_GetDisplayName
    vtb_GetAttributes
    vtb_Compare
End Enum

' ----==== Variablen ====----
Private m_Interface As InterfaceData

' ----==== Interface IShellItem Func ====----
Public Function BindToHandler(ByVal pbc As Long, ByVal rbhid As Long, ByVal riid _
    As Long) As Long

    Dim lRet As Long
    Dim ppvOut As Long
    Dim pppvOut As Long

    pppvOut = VarPtr(ppvOut)

    If x_OleInvoke(vtb_BindToHandler, pbc, rbhid, riid, pppvOut) Then

        lRet = ppvOut

    End If

    BindToHandler = lRet

End Function

Public Function GetParent() As Long

    Dim lRet As Long
    Dim ppsi As Long
    Dim pppsi As Long

    pppsi = VarPtr(ppsi)

    If x_OleInvoke(vtb_GetParent, pppsi) Then

        lRet = ppsi

    End If

    GetParent = lRet

End Function

Public Function GetDisplayName(ByVal sigdnName As SIGDN) As String

    Dim sRet As String
    Dim pszName As Long
    Dim ppszName As Long

    ppszName = VarPtr(pszName)

    If x_OleInvoke(vtb_GetDisplayName, sigdnName, ppszName) Then

        sRet = Ptr2Str(pszName)

    End If

    GetDisplayName = sRet

End Function

Public Function GetAttributes(ByVal sfgaoMask As SFGAO) As SFGAO

    Dim lRet As Long
    Dim psfgaoAttribs As Long
    Dim ppsfgaoAttribs As Long

    ppsfgaoAttribs = VarPtr(psfgaoAttribs)

    If x_OleInvoke(vtb_GetAttributes, sfgaoMask, ppsfgaoAttribs) Then

        lRet = psfgaoAttribs

    End If

    GetAttributes = lRet

End Function

Public Function Compare(ByVal psi As Long, ByVal hint As SICHINTF) As Long
    
    Dim lRet As Long
    Dim piOrder As Long
    Dim ppiOrder As Long
    
    ppiOrder = VarPtr(piOrder)
    
    If x_OleInvoke(vtb_Compare, psi, hint, ppiOrder) Then

        lRet = piOrder

    End If

    Compare = lRet
    
End Function

' ----==== Interface Helper Func ====----
'
' Initialisiert das Interface ber einen Interface-Pointer
Public Sub Init(ByVal pInterface As Long)

    If pInterface <> 0& Then

        m_Interface.pObject = ObjPtr(Me)
        m_Interface.boolRaiseErrors = False
        m_Interface.pInterface = pInterface

    End If

End Sub

' Ruft Release des Interfaces auf
Private Sub Class_Terminate()

    ' Kein ReleaseInterface fr die Rckgabe von IFileOperationProgressSink -> IShellItem !!!
    
    'Call ReleaseInterface(m_Interface)

End Sub

' Fhrt die Funktion des Interfaces aus
Private Function x_OleInvoke(ByVal vtb As E_vtbOffsets, ParamArray var()) As Boolean

    ' ist ein Pointer auf ein Interface vorhanden
    If m_Interface.pInterface <> 0& Then

        ' Funktion ausfhren
        x_OleInvoke = OleInvoke(m_Interface, vtb, var)

    End If

End Function

' wird aus der modInterface bei einem Fehler aufgerufen
Public Sub x_RaiseError(ByVal lngErrCode As Long, ByVal strErrText As String)

    Call Err.Raise(lngErrCode, App.EXEName & "\" & TypeName(Me), strErrText)

End Sub

' Fehler auslsen? Standard = False
Public Property Let RaiseErrors(ByVal Raise As Boolean)

    m_Interface.boolRaiseErrors = Raise

End Property

' liefert den Pointer auf das Interface zurck
Public Property Get IfcPtr() As Long

    IfcPtr = m_Interface.pInterface

End Property



