Attribute VB_Name = "modFunc"
Option Explicit

' ----==== Const ====----
Private Const S_OK As Long = &H0&
Private Const INVALID_FILE_ATTRIBUTES As Long = -1&

' ----==== Enums ====----
Public Enum FileAttributes
    FILE_ATTRIBUTE_READONLY = &H1
    FILE_ATTRIBUTE_HIDDEN = &H2
    FILE_ATTRIBUTE_SYSTEM = &H4
    FILE_ATTRIBUTE_DIRECTORY = &H10
    FILE_ATTRIBUTE_ARCHIVE = &H20
    FILE_ATTRIBUTE_DEVICE = &H40
    FILE_ATTRIBUTE_NORMAL = &H80
    FILE_ATTRIBUTE_TEMPORARY = &H100
    FILE_ATTRIBUTE_SPARSEFILE = &H200
    FILE_ATTRIBUTE_REPARSEPOINT = &H400
    FILE_ATTRIBUTE_COMPRESSED = &H800
    FILE_ATTRIBUTE_OFFLINE = &H1000
    FILE_ATTRIBUTE_NOTCONTENTINDEX = &H2000
    FILE_ATTRIBUTE_ENCRYPTED = &H4000
    FILE_ATTRIBUTE_INTEGRITYSTREAM = &H7FFF
    FILE_ATTRIBUTE_NOSCRUBDATA = &H20000
End Enum

Public Enum SIATTRIBFLAGS
    SIATTRIBFLAGS_AND = 1
    SIATTRIBFLAGS_APPCOMPAT = 3
    SIATTRIBFLAGS_OR = 2
End Enum

Public Enum GETPROPERTYSTOREFLAGS
    GPS_DEFAULT = &H0
    GPS_HANDLERPROPERTIESONLY = &H1
    GPS_READWRITE = &H2
    GPS_TEMPORARY = &H4
    GPS_FASTPROPERTIESONLY = &H8
    GPS_OPENSLOWITEM = &H10
    GPS_DELAYCREATION = &H20
    GPS_BESTEFFORT = &H40
    GPS_NO_OPLOCK = &H80
    GPS_MASK_VALID = &HFF
End Enum

Public Enum SICHINTF
    SICHINT_DISPLAY = &H0
    SICHINT_ALLFIELDS = &H80000000
    SICHINT_CANONICAL = &H10000000
    SICHINT_TEST_FILESYSPATH_IF_NOT_EQUAL = &H20000000
End Enum

Public Enum SIGDN
    SIGDN_NORMALDISPLAY = &H0
    SIGDN_PARENTRELATIVEPARSING = &H80018001
    SIGDN_DESKTOPABSOLUTEPARSING = &H80028000
    SIGDN_PARENTRELATIVEEDITING = &H80031001
    SIGDN_DESKTOPABSOLUTEEDITING = &H8004C000
    SIGDN_FILESYSPATH = &H80058000
    SIGDN_URL = &H80068000
    SIGDN_PARENTRELATIVEFORADDRESSBAR = &H8007C001
    SIGDN_PARENTRELATIVE = &H80080001
    SIGDN_PARENTRELATIVEFORUI = &H80094001
End Enum

Public Enum SFGAO
    SFGAO_CANCOPY = &H1
    SFGAO_CANMOVE = &H2
    SFGAO_CANLINK = &H4
    SFGAO_STORAGE = &H8
    SFGAO_CANRENAME = &H10
    SFGAO_CANDELETE = &H20
    SFGAO_HASPROPSHEET = &H40
    SFGAO_DROPTARGET = &H100
    SFGAO_CAPABILITYMASK = &H177
    SFGAO_ENCRYPTED = &H2000
    SFGAO_ISSLOW = &H4000
    SFGAO_GHOSTED = &H8000
    SFGAO_LINK = &H10000
    SFGAO_SHARE = &H20000
    SFGAO_READONLY = &H40000
    SFGAO_HIDDEN = &H80000
    SFGAO_DISPLAYATTRMASK = &HFC000
    SFGAO_FILESYSANCESTOR = &H10000000
    SFGAO_FOLDER = &H20000000
    SFGAO_FILESYSTEM = &H40000000
    SFGAO_HASSUBFOLDER = &H80000000
    SFGAO_CONTENTSMASK = &H80000000
    SFGAO_VALIDATE = &H1000000
    SFGAO_REMOVABLE = &H2000000
    SFGAO_COMPRESSED = &H4000000
    SFGAO_BROWSABLE = &H8000000
    SFGAO_NONENUMERATED = &H100000
    SFGAO_NEWCONTENT = &H200000
    SFGAO_CANMONIKER = &H400000
    SFGAO_HASSTORAGE = &H400000
    SFGAO_STREAM = &H400000
    SFGAO_STORAGEANCESTOR = &H800000
    SFGAO_STORAGECAPMASK = &H70C50008
End Enum

Public Enum PROGDLG
    PROGDLG_NORMAL = &H0
    PROGDLG_MODAL = &H1
    PROGDLG_AUTOTIME = &H2
    PROGDLG_NOTIME = &H4
    PROGDLG_NOMINIMIZE = &H8
    PROGDLG_NOPROGRESSBAR = &H10
    PROGDLG_MARQUEEPROGRESS = &H20
    PROGDLG_NOCANCEL = &H40
    OPPROGDLG_DEFAULT = &H0
    OPPROGDLG_ENABLEPAUSE = &H80
    OPPROGDLG_ALLOWUNDO = &H100
    OPPROGDLG_DONTDISPLAYSOURCEPATH = &H200
    OPPROGDLG_DONTDISPLAYDESTPATH = &H400
    OPPROGDLG_NOMULTIDAYESTIMATES = &H800
    OPPROGDLG_DONTDISPLAYLOCATIONS = &H1000
End Enum

Public Enum SPACTION
    SPACTION_NONE = 0
    SPACTION_MOVING
    SPACTION_COPYING
    SPACTION_RECYCLING
    SPACTION_APPLYINGATTRIBS
    SPACTION_DOWNLOADING
    SPACTION_SEARCHING_INTERNET
    SPACTION_CALCULATING
    SPACTION_UPLOADING
    SPACTION_SEARCHING_FILES
    SPACTION_DELETING
    SPACTION_RENAMING
    SPACTION_FORMATTING
    SPACTION_COPY_MOVING
End Enum

Public Enum PDMODE
    PDM_DEFAULT = &H0
    PDM_RUN = &H1
    PDM_PREFLIGHT = &H2
    PDM_UNDOING = &H4
    PDM_ERRORSBLOCKING = &H8
    PDM_INDETERMINATE = &H10
End Enum

Public Enum PDOPSTATUS
    PDOPS_RUNNING = 1
    PDOPS_PAUSED = 2
    PDOPS_CANCELLED = 3
    PDOPS_STOPPED = 4
    PDOPS_ERRORS = 5
End Enum

Public Enum FileOperationFlags
    'FOF_MULTIDESTFILES = &H1
    'FOF_CONFIRMMOUSE = &H2
    FOF_SILENT = &H4
    FOF_RENAMEONCOLLISION = &H8
    FOF_NOCONFIRMATION = &H10
    'FOF_WANTMAPPINGHANDLE = &H20
    FOF_ALLOWUNDO = &H40
    FOF_FILESONLY = &H80
    'FOF_SIMPLEPROGRESS = &H100
    FOF_NOCONFIRMMKDIR = &H200
    FOF_NOERRORUI = &H400
    FOF_NORECURSION = &H1000
    FOF_NOCOPYSECURITYATTRIBS = &H800
    FOF_NO_CONNECTED_ELEMENTS = &H2000
    FOF_WANTNUKEWARNING = &H4000
    FOF_NORECURSEREPARSE = &H8000&
    FOF_NO_UI = FOF_SILENT Or FOF_NOCONFIRMATION Or FOF_NOERRORUI Or FOF_NOCONFIRMMKDIR
    FOF_DEFAULT = FOF_ALLOWUNDO Or FOF_NOCONFIRMMKDIR
    FOFX_NOSKIPJUNCTIONS = &H10000
    FOFX_PREFERHARDLINK = &H20000
    FOFX_SHOWELEVATIONPROMPT = &H40000
    FOFX_RECYCLEONDELETE = &H80000
    FOFX_EARLYFAILURE = &H100000
    FOFX_PRESERVEFILEEXTENSIONS = &H200000
    FOFX_KEEPNEWERFILE = &H400000
    FOFX_NOCOPYHOOKS = &H800000
    FOFX_NOMINIMIZEBOX = &H1000000
    FOFX_MOVEACLSACROSSVOLUMES = &H2000000
    FOFX_DONTDISPLAYSOURCEPATH = &H4000000
    FOFX_DONTDISPLAYDESTPATH = &H8000000
    FOFX_REQUIREELEVATION = &H10000000
    FOFX_ADDUNDORECORD = &H20000000
    FOFX_COPYASDOWNLOAD = &H40000000
    FOFX_DONTDISPLAYLOCATIONS = &H80000000
End Enum

Public Enum TRANSFER_SOURCE_FLAGS
    TSF_NORMAL = 0
    TSF_FAIL_EXIST = 0
    TSF_RENAME_EXIST = &H1
    TSF_OVERWRITE_EXIST = &H2
    TSF_ALLOW_DECRYPTION = &H4
    TSF_NO_SECURITY = &H8
    TSF_COPY_CREATION_TIME = &H10
    TSF_COPY_WRITE_TIME = &H20
    TSF_USE_FULL_ACCESS = &H40
    TSF_DELETE_RECYCLE_IF_POSSIBLE = &H80
    TSF_COPY_HARD_LINK = &H100
    TSF_COPY_LOCALIZED_NAME = &H200
    TSF_MOVE_AS_COPY_DELETE = &H400
    TSF_SUSPEND_SHELLEVENTS = &H800
End Enum

' ----==== Types ====----
Public Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
End Type

Public Type ULONGLONG
    LowLong As Long
    HighLong As Long
End Type

Public Type PROPERTYKEY
    fmtid As GUID
    pid As Long
End Type

' ----==== Ole32 API-Deklarationen ====----
Public Declare Sub CoTaskMemFree Lib "ole32.dll" ( _
                   ByVal hMem As Long)

Public Declare Function StringFromCLSID Lib "ole32.dll" ( _
                        ByRef pCLSID As GUID, _
                        ByRef lpszProgID As Long) As Long

' ----==== Kernel32 API-Deklarationen ====----
Public Declare Sub RtlMoveMemory Lib "kernel32" ( _
                   ByRef hpvDest As Any, _
                   ByRef hpvSource As Any, _
                   ByVal cbCopy As Long)

Private Declare Function lstrlenW Lib "kernel32" ( _
                         ByVal lpString As Long) As Long

Private Declare Function GetFileAttributes Lib "kernel32" _
                         Alias "GetFileAttributesA" ( _
                         ByVal lpFileName As String) As Long

' ----==== Shell32 API-Deklarationen ====----
Private Declare Function SHGetDesktopFolder Lib "shell32" ( _
                         ByRef ppshf As Long) As Long

Private Declare Function SHCreateShellItem Lib "shell32" ( _
                         ByVal pidlParent As Long, _
                         ByVal psfParent As Long, _
                         ByVal pidl As Long, _
                         ByRef ppsi As Long) As Long

Private Declare Function SHCreateShellItemArrayFromIDLists Lib "shell32" ( _
                         ByVal cidl As Long, _
                         ByVal rgpidl As Long, _
                         ByRef ppsiItemArray As Long) As Long

' **************** Imagehlp.dll ****************
Private Declare Function MakePath Lib "imagehlp" _
                         Alias "MakeSureDirectoryPathExists" ( _
                         ByVal lpPath As String) As Long

' umbenennen einer Datei oder eines Ordners
Public Function RenameItem(ByVal sFileOrFolder As String, ByVal sNewName As _
    String, Optional ByVal flags As FileOperationFlags = FOF_DEFAULT, Optional ByVal _
    hwndOwner As Long = 0&, Optional ByVal IOps As clsIFileOperationProgressSink = _
    Nothing, Optional ByVal IOpd As clsIOperationsProgressDialog = Nothing, _
    Optional ByVal IOpdFlags As PROGDLG = PROGDLG_NORMAL) As Boolean

    Dim bRet As Boolean
    Dim lCookie As Long
    Dim lSrcPIDL As Long
    Dim pIOps As Long
    Dim pSrcIShellItem As Long
    Dim IShellItemSrc As clsIShellItem
    Dim IFileOperation As clsIFileOperation

    bRet = False

    ' PIDL der Datei oder Ordner ermitteln (Quelle)
    lSrcPIDL = GetPIDLFromPath(sFileOrFolder)

    ' ist eine PIDL vorhanden
    If lSrcPIDL <> 0& Then

        ' IShellItem von der Quelle erstellen
        If SHCreateShellItem(0&, 0&, lSrcPIDL, pSrcIShellItem) = S_OK Then

            ' IShellItem initialisieren
            Set IShellItemSrc = New clsIShellItem
            Call IShellItemSrc.Init(pSrcIShellItem)

            ' IFileOperation Interface erstellen
            Set IFileOperation = New clsIFileOperation

            ' ist ein IFileOperationProgressSink vorhanden
            ' dann diesen IFileOperation zuweisen
            If Not IOps Is Nothing Then

                ' Pointer speichern
                pIOps = IOps.IfcPtr

                ' Cookie <> 0 wenn erfolgreich
                lCookie = IFileOperation.Advise(pIOps)

            End If

            ' ist ein IOperationsProgressDialog vorhanden
            ' dann diesen IFileOperation zuweisen
            If Not IOpd Is Nothing Then Call IFileOperation.SetProgressDialog( _
                IOpd.IfcPtr)

            ' div. Eigenschaften festlegen
            If IFileOperation.SetOwnerWindow(hwndOwner) = True Then

                If IFileOperation.SetOperationFlags(flags) = True Then

                    ' Umbenennen
                    If IFileOperation.RenameItem(pSrcIShellItem, sNewName, pIOps) _
                        = True Then

                        ' ist ein IOperationsProgressDialog vorhanden
                        ' dann diesen Dialog starten
                        If Not IOpd Is Nothing Then Call IOpd.StartProgressDialog( _
                            hwndOwner, IOpdFlags)

                        ' Aktion ausfhren
                        If IFileOperation.PerformOperations = True Then

                            ' wenn die Operation nicht abgebrochen wurde
                            If IFileOperation.GetAnyOperationAborted = False Then

                                bRet = True

                            End If

                        End If

                        ' ist ein IOperationsProgressDialog vorhanden
                        ' dann diesen Dialog stoppen
                        If Not IOpd Is Nothing Then Call IOpd.StopProgressDialog

                    End If

                End If

            End If

            ' ist ein Cookie (Advice) vorhanden
            If lCookie <> 0& Then

                ' Zuweisung aufheben
                Call IFileOperation.Unadvise(lCookie)

            End If

            ' Aufrumen
            Set IFileOperation = Nothing

            ' Aufrumen
            Set IShellItemSrc = Nothing

        End If

        ' Aufrumen
        Call CoTaskMemFree(lSrcPIDL)

    End If

    RenameItem = bRet

End Function

' mehrer Dateien oder Ordner umbenennen
Public Function RenameItems(ByRef sFileOrFolder() As String, ByVal sNewName As _
    String, Optional ByVal flags As FileOperationFlags = FOF_DEFAULT, Optional ByVal _
    hwndOwner As Long = 0&, Optional ByVal IOps As clsIFileOperationProgressSink = _
    Nothing, Optional ByVal IOpd As clsIOperationsProgressDialog = Nothing, _
    Optional ByVal IOpdFlags As PROGDLG = PROGDLG_NORMAL) As Boolean

    Dim bRet As Boolean
    Dim lCookie As Long
    Dim lItem As Long
    Dim lCount As Long
    Dim lCounter As Long
    Dim lPIDL As Long
    Dim pSrcPIDL As Long
    Dim lSrcPIDL() As Long
    Dim pSrcIShellItemArray As Long
    Dim IFileOperation As clsIFileOperation
    Dim IShellItemArraySrc As clsIShellItemArray

    bRet = False
    lCounter = 0

    ' Anzahl der Dateien oder Ordner (Quelle)
    lCount = UBound(sFileOrFolder)

    ' Alle Items durchlaufen
    For lItem = 0 To lCount

        ' wenn lCounter = 0
        If lCounter = 0 Then

            ' Array initialisieren
            ReDim lSrcPIDL(lCounter)

        Else

            ' ansonsten Array vergrern
            ReDim Preserve lSrcPIDL(lCounter)

        End If

        ' PIDL von Datei oder Ordner ermitteln
        lPIDL = GetPIDLFromPath(sFileOrFolder(lCounter))

        ' ist eine PIDL vorhanden
        If lPIDL <> 0& Then

            ' PIDL speichern
            lSrcPIDL(lCounter) = lPIDL

            ' Zhler erhhen
            lCounter = lCounter + 1

        End If

    Next

    ' Pointer auf das Quellarray mit PIDLs
    pSrcPIDL = VarPtr(lSrcPIDL(0))

    ' Interface IShellItemArray von Quellarray erstellen
    If SHCreateShellItemArrayFromIDLists(lCounter, pSrcPIDL, pSrcIShellItemArray) _
        = S_OK Then

        ' IShellItemArray initialisieren
        Set IShellItemArraySrc = New clsIShellItemArray
        Call IShellItemArraySrc.Init(pSrcIShellItemArray)

        ' Interface IFileOperation erstellen
        Set IFileOperation = New clsIFileOperation

        ' ist ein IFileOperationProgressSink vorhanden
        If Not IOps Is Nothing Then lCookie = IFileOperation.Advise(IOps.IfcPtr)

        ' ist ein IOperationsProgressDialog vorhanden
        If Not IOpd Is Nothing Then Call IFileOperation.SetProgressDialog( _
            IOpd.IfcPtr)

        ' div. Eigenschaften festlegen
        If IFileOperation.SetOwnerWindow(hwndOwner) = True Then

            If IFileOperation.SetOperationFlags(flags) = True Then

                ' Umbenennen
                If IFileOperation.RenameItems(pSrcIShellItemArray, sNewName) = _
                    True Then

                    If Not IOpd Is Nothing Then Call IOpd.StartProgressDialog( _
                        hwndOwner, IOpdFlags)

                    ' Aktion ausfhren
                    If IFileOperation.PerformOperations = True Then

                        ' wenn die Operation nicht abgebrochen wurde
                        If IFileOperation.GetAnyOperationAborted = False Then

                            bRet = True

                        End If

                    End If

                    If Not IOpd Is Nothing Then Call IOpd.StopProgressDialog

                End If

            End If

        End If

        ' ist ein Cookie (Advice) vorhanden
        If lCookie <> 0& Then

            ' Zuweisung aufheben
            Call IFileOperation.Unadvise(lCookie)

        End If

        ' Aufrumen
        Set IFileOperation = Nothing

        ' Aufrumen
        Set IShellItemArraySrc = Nothing

    End If

    ' alle PIDLs in Quellarray durchlaufen
    For lItem = 0 To lCounter - 1

        ' Aufrumen
        Call CoTaskMemFree(lSrcPIDL(lItem))

    Next

    RenameItems = bRet

End Function

' Verschiebt eine Datei oder ein Ordner zu einem anderen Ordner
Public Function MoveItem(ByVal sFileOrFolder As String, ByVal sToFolder As String, _
    Optional ByVal flags As FileOperationFlags = FOF_DEFAULT, Optional ByVal _
    hwndOwner As Long = 0&, Optional ByVal IOps As clsIFileOperationProgressSink = _
    Nothing, Optional ByVal IOpd As clsIOperationsProgressDialog = Nothing, _
    Optional ByVal IOpdFlags As PROGDLG = PROGDLG_NORMAL) As Boolean

    Dim bRet As Boolean
    Dim lCookie As Long
    Dim lSrcPIDL As Long
    Dim lDstPIDL As Long
    Dim pIOps As Long
    Dim pSrcIShellItem As Long
    Dim pDstIShellItem As Long
    Dim IShellItemSrc As clsIShellItem
    Dim IShellItemDst As clsIShellItem
    Dim IFileOperation As clsIFileOperation

    bRet = False

    lSrcPIDL = GetPIDLFromPath(sFileOrFolder)

    If lSrcPIDL <> 0& Then

        If DirExists(sToFolder) = False Then

            Call CreatePath(sToFolder)

        End If

        lDstPIDL = GetPIDLFromPath(sToFolder)

        If lDstPIDL <> 0& Then

            If SHCreateShellItem(0&, 0&, lSrcPIDL, pSrcIShellItem) = S_OK Then

                Set IShellItemSrc = New clsIShellItem
                Call IShellItemSrc.Init(pSrcIShellItem)

                If SHCreateShellItem(0&, 0&, lDstPIDL, pDstIShellItem) = S_OK Then

                    Set IShellItemDst = New clsIShellItem
                    Call IShellItemDst.Init(pDstIShellItem)

                    Set IFileOperation = New clsIFileOperation

                    If Not IOps Is Nothing Then

                        pIOps = IOps.IfcPtr

                        lCookie = IFileOperation.Advise(pIOps)

                    End If

                    If Not IOpd Is Nothing Then Call _
                        IFileOperation.SetProgressDialog(IOpd.IfcPtr)

                    If IFileOperation.SetOwnerWindow(hwndOwner) = True Then

                        If IFileOperation.SetOperationFlags(flags) = True Then

                            If IFileOperation.MoveItem(pSrcIShellItem, _
                                pDstIShellItem, vbNullString, pIOps) = True Then

                                If Not IOpd Is Nothing Then Call _
                                    IOpd.StartProgressDialog(hwndOwner, IOpdFlags)

                                If IFileOperation.PerformOperations = True Then

                                    If IFileOperation.GetAnyOperationAborted = _
                                        False Then

                                        bRet = True

                                    End If

                                End If

                                If Not IOpd Is Nothing Then Call _
                                    IOpd.StopProgressDialog

                            End If

                        End If

                    End If

                    If lCookie <> 0& Then

                        Call IFileOperation.Unadvise(lCookie)

                    End If

                    Set IFileOperation = Nothing

                    Set IShellItemDst = Nothing

                End If

                Set IShellItemSrc = Nothing

            End If

            Call CoTaskMemFree(lDstPIDL)

        End If

        Call CoTaskMemFree(lSrcPIDL)

    End If

    MoveItem = bRet

End Function

' Verschiebt mehrere Dateien oder Ordner zu einem anderen Ordner
Public Function MoveItems(ByRef sFileOrFolder() As String, ByVal sToFolder As _
    String, Optional ByVal flags As FileOperationFlags = FOF_DEFAULT, Optional ByVal _
    hwndOwner As Long = 0&, Optional ByVal IOps As clsIFileOperationProgressSink = _
    Nothing, Optional ByVal IOpd As clsIOperationsProgressDialog = Nothing, _
    Optional ByVal IOpdFlags As PROGDLG = PROGDLG_NORMAL) As Boolean

    Dim bRet As Boolean
    Dim lCookie As Long
    Dim lItem As Long
    Dim lCount As Long
    Dim lCounter As Long
    Dim lPIDL As Long
    Dim pSrcPIDL As Long
    Dim lSrcPIDL() As Long
    Dim lDstPIDL As Long
    Dim pDstIShellItem As Long
    Dim pSrcIShellItemArray As Long
    Dim IShellItemDst As clsIShellItem
    Dim IFileOperation As clsIFileOperation
    Dim IShellItemArraySrc As clsIShellItemArray

    bRet = False
    lCounter = 0

    lCount = UBound(sFileOrFolder)

    For lItem = 0 To lCount

        If lCounter = 0 Then

            ReDim lSrcPIDL(lCounter)

        Else

            ReDim Preserve lSrcPIDL(lCounter)

        End If

        lPIDL = GetPIDLFromPath(sFileOrFolder(lCounter))

        If lPIDL <> 0& Then

            lSrcPIDL(lCounter) = lPIDL
            lCounter = lCounter + 1

        End If

    Next

    If DirExists(sToFolder) = False Then

        Call CreatePath(sToFolder)

    End If

    lDstPIDL = GetPIDLFromPath(sToFolder)

    If lDstPIDL <> 0& Then

        pSrcPIDL = VarPtr(lSrcPIDL(0))

        If SHCreateShellItemArrayFromIDLists(lCounter, pSrcPIDL, _
            pSrcIShellItemArray) = S_OK Then

            Set IShellItemArraySrc = New clsIShellItemArray
            Call IShellItemArraySrc.Init(pSrcIShellItemArray)

            If SHCreateShellItem(0&, 0&, lDstPIDL, pDstIShellItem) = S_OK Then

                Set IShellItemDst = New clsIShellItem
                Call IShellItemDst.Init(pDstIShellItem)

                Set IFileOperation = New clsIFileOperation

                If Not IOps Is Nothing Then lCookie = IFileOperation.Advise( _
                    IOps.IfcPtr)

                If Not IOpd Is Nothing Then Call IFileOperation.SetProgressDialog( _
                    IOpd.IfcPtr)

                If IFileOperation.SetOwnerWindow(hwndOwner) = True Then

                    If IFileOperation.SetOperationFlags(flags) = True Then

                        If IFileOperation.MoveItems(pSrcIShellItemArray, _
                            pDstIShellItem) = True Then

                            If Not IOpd Is Nothing Then Call _
                                IOpd.StartProgressDialog(hwndOwner, IOpdFlags)

                            If IFileOperation.PerformOperations = True Then

                                If IFileOperation.GetAnyOperationAborted = False _
                                    Then

                                    bRet = True

                                End If

                            End If

                            If Not IOpd Is Nothing Then Call IOpd.StopProgressDialog

                        End If

                    End If

                End If

                If lCookie <> 0& Then

                    Call IFileOperation.Unadvise(lCookie)

                End If

                Set IFileOperation = Nothing

                Set IShellItemDst = Nothing

            End If

            Set IShellItemArraySrc = Nothing

        End If

        For lItem = 0 To lCounter - 1

            Call CoTaskMemFree(lSrcPIDL(lItem))

        Next

        Call CoTaskMemFree(lDstPIDL)

    End If

    MoveItems = bRet

End Function

' kopiert eine Datei oder einen Ordner zu einem anderen Ordner
Public Function CopyItem(ByVal sFileOrFolder As String, ByVal sToFolder As String, _
    Optional ByVal flags As FileOperationFlags = FOF_DEFAULT, Optional ByVal _
    hwndOwner As Long = 0&, Optional ByVal IOps As clsIFileOperationProgressSink = _
    Nothing, Optional ByVal IOpd As clsIOperationsProgressDialog = Nothing, _
    Optional ByVal IOpdFlags As PROGDLG = PROGDLG_NORMAL) As Boolean

    Dim bRet As Boolean
    Dim lCookie As Long
    Dim lSrcPIDL As Long
    Dim lDstPIDL As Long
    Dim pIOps As Long
    Dim pSrcIShellItem As Long
    Dim pDstIShellItem As Long
    Dim IShellItemSrc As clsIShellItem
    Dim IShellItemDst As clsIShellItem
    Dim IFileOperation As clsIFileOperation

    bRet = False

    lSrcPIDL = GetPIDLFromPath(sFileOrFolder)

    If lSrcPIDL <> 0& Then

        If DirExists(sToFolder) = False Then

            Call CreatePath(sToFolder)

        End If

        lDstPIDL = GetPIDLFromPath(sToFolder)

        If lDstPIDL <> 0& Then

            If SHCreateShellItem(0&, 0&, lSrcPIDL, pSrcIShellItem) = S_OK Then

                Set IShellItemSrc = New clsIShellItem
                Call IShellItemSrc.Init(pSrcIShellItem)

                If SHCreateShellItem(0&, 0&, lDstPIDL, pDstIShellItem) = S_OK Then

                    Set IShellItemDst = New clsIShellItem
                    Call IShellItemDst.Init(pDstIShellItem)

                    Set IFileOperation = New clsIFileOperation

                    If Not IOps Is Nothing Then

                        pIOps = IOps.IfcPtr

                        lCookie = IFileOperation.Advise(pIOps)

                    End If

                    If Not IOpd Is Nothing Then Call _
                        IFileOperation.SetProgressDialog(IOpd.IfcPtr)

                    If IFileOperation.SetOwnerWindow(hwndOwner) = True Then

                        If IFileOperation.SetOperationFlags(flags) = True Then

                            If IFileOperation.CopyItem(pSrcIShellItem, _
                                pDstIShellItem, vbNullString, pIOps) = True Then

                                If Not IOpd Is Nothing Then Call _
                                    IOpd.StartProgressDialog(hwndOwner, IOpdFlags)

                                If IFileOperation.PerformOperations = True Then

                                    If IFileOperation.GetAnyOperationAborted = _
                                        False Then

                                        bRet = True

                                    End If

                                End If

                                If Not IOpd Is Nothing Then Call _
                                    IOpd.StopProgressDialog

                            End If

                        End If

                    End If

                    If lCookie <> 0& Then

                        Call IFileOperation.Unadvise(lCookie)

                    End If

                    Set IFileOperation = Nothing

                    Set IShellItemDst = Nothing

                End If

                Set IShellItemSrc = Nothing

            End If

            Call CoTaskMemFree(lDstPIDL)

        End If

        Call CoTaskMemFree(lSrcPIDL)

    End If

    CopyItem = bRet

End Function

' kopiert mehrere Dateien oder Ordner zu einem anderen Ordner
Public Function CopyItems(ByRef sFileOrFolder() As String, ByVal sToFolder As _
    String, Optional ByVal flags As FileOperationFlags = FOF_DEFAULT, Optional ByVal _
    hwndOwner As Long = 0&, Optional ByVal IOps As clsIFileOperationProgressSink = _
    Nothing, Optional ByVal IOpd As clsIOperationsProgressDialog = Nothing, _
    Optional ByVal IOpdFlags As PROGDLG = PROGDLG_NORMAL) As Boolean

    Dim bRet As Boolean
    Dim lCookie As Long
    Dim lItem As Long
    Dim lCount As Long
    Dim lCounter As Long
    Dim lPIDL As Long
    Dim pSrcPIDL As Long
    Dim lSrcPIDL() As Long
    Dim lDstPIDL As Long
    Dim pDstIShellItem As Long
    Dim pSrcIShellItemArray As Long
    Dim IShellItemDst As clsIShellItem
    Dim IFileOperation As clsIFileOperation
    Dim IShellItemArraySrc As clsIShellItemArray

    bRet = False
    lCounter = 0

    lCount = UBound(sFileOrFolder)

    For lItem = 0 To lCount

        If lCounter = 0 Then

            ReDim lSrcPIDL(lCounter)

        Else

            ReDim Preserve lSrcPIDL(lCounter)

        End If

        lPIDL = GetPIDLFromPath(sFileOrFolder(lCounter))

        If lPIDL <> 0& Then

            lSrcPIDL(lCounter) = lPIDL

            lCounter = lCounter + 1

        End If

    Next

    If DirExists(sToFolder) = False Then

        Call CreatePath(sToFolder)

    End If

    lDstPIDL = GetPIDLFromPath(sToFolder)

    If lDstPIDL <> 0& Then

        pSrcPIDL = VarPtr(lSrcPIDL(0))

        If SHCreateShellItemArrayFromIDLists(lCounter, pSrcPIDL, _
            pSrcIShellItemArray) = S_OK Then

            Set IShellItemArraySrc = New clsIShellItemArray
            Call IShellItemArraySrc.Init(pSrcIShellItemArray)

            If SHCreateShellItem(0&, 0&, lDstPIDL, pDstIShellItem) = S_OK Then

                Set IShellItemDst = New clsIShellItem
                Call IShellItemDst.Init(pDstIShellItem)

                Set IFileOperation = New clsIFileOperation

                If Not IOps Is Nothing Then lCookie = IFileOperation.Advise( _
                    IOps.IfcPtr)

                If Not IOpd Is Nothing Then Call IFileOperation.SetProgressDialog( _
                    IOpd.IfcPtr)

                If IFileOperation.SetOwnerWindow(hwndOwner) = True Then

                    If IFileOperation.SetOperationFlags(flags) = True Then

                        If IFileOperation.CopyItems(pSrcIShellItemArray, _
                            pDstIShellItem) = True Then

                            If Not IOpd Is Nothing Then Call _
                                IOpd.StartProgressDialog(hwndOwner, IOpdFlags)

                            If IFileOperation.PerformOperations = True Then

                                If IFileOperation.GetAnyOperationAborted = False _
                                    Then

                                    bRet = True

                                End If

                            End If

                            If Not IOpd Is Nothing Then Call IOpd.StopProgressDialog

                        End If

                    End If

                End If

                If lCookie <> 0& Then

                    Call IFileOperation.Unadvise(lCookie)

                End If

                Set IFileOperation = Nothing

                Set IShellItemDst = Nothing

            End If

            Set IShellItemArraySrc = Nothing

        End If

        For lItem = 0 To lCounter - 1

            Call CoTaskMemFree(lSrcPIDL(lItem))

        Next

        Call CoTaskMemFree(lDstPIDL)

    End If

    CopyItems = bRet

End Function

' lscht eine Datei oder Ordner
Public Function DeleteItem(ByVal sFileOrFolder As String, Optional ByVal flags As _
    FileOperationFlags = FOF_DEFAULT, Optional ByVal hwndOwner As Long = 0&, _
    Optional ByVal IOps As clsIFileOperationProgressSink = Nothing, Optional ByVal _
    IOpd As clsIOperationsProgressDialog = Nothing, Optional ByVal IOpdFlags As _
    PROGDLG = PROGDLG_NORMAL) As Boolean

    Dim bRet As Boolean
    Dim lCookie As Long
    Dim lSrcPIDL As Long
    Dim pIOps As Long
    Dim pSrcIShellItem As Long
    Dim IShellItemSrc As clsIShellItem
    Dim IFileOperation As clsIFileOperation

    bRet = False

    lSrcPIDL = GetPIDLFromPath(sFileOrFolder)

    If lSrcPIDL <> 0& Then

        If SHCreateShellItem(0&, 0&, lSrcPIDL, pSrcIShellItem) = S_OK Then

            Set IShellItemSrc = New clsIShellItem
            Call IShellItemSrc.Init(pSrcIShellItem)

            Set IFileOperation = New clsIFileOperation

            If Not IOps Is Nothing Then

                pIOps = IOps.IfcPtr

                lCookie = IFileOperation.Advise(pIOps)

            End If

            If Not IOpd Is Nothing Then Call IFileOperation.SetProgressDialog( _
                IOpd.IfcPtr)

            If IFileOperation.SetOwnerWindow(hwndOwner) = True Then

                If IFileOperation.SetOperationFlags(flags) = True Then

                    If IFileOperation.DeleteItem(pSrcIShellItem, pIOps) = True Then

                        If Not IOpd Is Nothing Then Call IOpd.StartProgressDialog( _
                            hwndOwner, IOpdFlags)

                        If IFileOperation.PerformOperations = True Then

                            If IFileOperation.GetAnyOperationAborted = False Then

                                bRet = True

                            End If

                        End If

                        If Not IOpd Is Nothing Then Call IOpd.StopProgressDialog

                    End If

                End If

            End If

            If lCookie <> 0& Then

                Call IFileOperation.Unadvise(lCookie)

            End If

            Set IFileOperation = Nothing

            Set IShellItemSrc = Nothing

        End If

        Call CoTaskMemFree(lSrcPIDL)

    End If

    DeleteItem = bRet

End Function

' lscht mehrere Dateien oder Ordner
Public Function DeleteItems(ByRef sFileOrFolder() As String, Optional ByVal flags _
    As FileOperationFlags = FOF_DEFAULT, Optional ByVal hwndOwner As Long = 0&, _
    Optional ByVal IOps As clsIFileOperationProgressSink = Nothing, Optional ByVal _
    IOpd As clsIOperationsProgressDialog = Nothing, Optional ByVal IOpdFlags As _
    PROGDLG = PROGDLG_NORMAL) As Boolean

    Dim bRet As Boolean
    Dim lCookie As Long
    Dim lItem As Long
    Dim lCount As Long
    Dim lCounter As Long
    Dim lPIDL As Long
    Dim pSrcPIDL As Long
    Dim lSrcPIDL() As Long
    Dim pSrcIShellItemArray As Long
    Dim IFileOperation As clsIFileOperation
    Dim IShellItemArraySrc As clsIShellItemArray

    bRet = False
    lCounter = 0

    lCount = UBound(sFileOrFolder)

    For lItem = 0 To lCount

        If lCounter = 0 Then

            ReDim lSrcPIDL(lCounter)

        Else

            ReDim Preserve lSrcPIDL(lCounter)

        End If

        lPIDL = GetPIDLFromPath(sFileOrFolder(lCounter))

        If lPIDL <> 0& Then

            lSrcPIDL(lCounter) = lPIDL

            lCounter = lCounter + 1

        End If

    Next

    pSrcPIDL = VarPtr(lSrcPIDL(0))

    If SHCreateShellItemArrayFromIDLists(lCounter, pSrcPIDL, pSrcIShellItemArray) _
        = S_OK Then

        Set IShellItemArraySrc = New clsIShellItemArray
        Call IShellItemArraySrc.Init(pSrcIShellItemArray)

        Set IFileOperation = New clsIFileOperation

        If Not IOps Is Nothing Then lCookie = IFileOperation.Advise(IOps.IfcPtr)

        If Not IOpd Is Nothing Then Call IFileOperation.SetProgressDialog( _
            IOpd.IfcPtr)

        If IFileOperation.SetOwnerWindow(hwndOwner) = True Then

            If IFileOperation.SetOperationFlags(flags) = True Then

                If IFileOperation.DeleteItems(pSrcIShellItemArray) = True Then

                    If Not IOpd Is Nothing Then Call IOpd.StartProgressDialog( _
                        hwndOwner, IOpdFlags)

                    If IFileOperation.PerformOperations = True Then

                        If IFileOperation.GetAnyOperationAborted = False Then

                            bRet = True

                        End If

                    End If

                    If Not IOpd Is Nothing Then Call IOpd.StopProgressDialog

                End If

            End If

        End If

        If lCookie <> 0& Then

            Call IFileOperation.Unadvise(lCookie)

        End If

        Set IFileOperation = Nothing

        Set IShellItemArraySrc = Nothing

    End If

    For lItem = 0 To lCounter - 1

        Call CoTaskMemFree(lSrcPIDL(lItem))

    Next

    DeleteItems = bRet

End Function

Public Function NewItem(ByVal sFolder As String, ByVal dwFileAttributes As _
    FileAttributes, ByVal szName As String, ByVal szTemplateName As String, _
    Optional ByVal flags As FileOperationFlags = FOF_DEFAULT, Optional ByVal _
    hwndOwner As Long = 0&, Optional ByVal IOps As clsIFileOperationProgressSink = _
    Nothing, Optional ByVal IOpd As clsIOperationsProgressDialog = Nothing, _
    Optional ByVal IOpdFlags As PROGDLG = PROGDLG_NORMAL) As Boolean

    Dim bRet As Boolean
    Dim lCookie As Long
    Dim lDstPIDL As Long
    Dim pIOps As Long
    Dim pDstIShellItem As Long
    Dim IShellItemDst As clsIShellItem
    Dim IFileOperation As clsIFileOperation

    bRet = False

    lDstPIDL = GetPIDLFromPath(sFolder)

    If lDstPIDL <> 0& Then

        If SHCreateShellItem(0&, 0&, lDstPIDL, pDstIShellItem) = S_OK Then

            Set IShellItemDst = New clsIShellItem
            Call IShellItemDst.Init(pDstIShellItem)

            Set IFileOperation = New clsIFileOperation

            If Not IOps Is Nothing Then

                pIOps = IOps.IfcPtr

                lCookie = IFileOperation.Advise(pIOps)

            End If

            If Not IOpd Is Nothing Then Call IFileOperation.SetProgressDialog( _
                IOpd.IfcPtr)

            If IFileOperation.SetOwnerWindow(hwndOwner) = True Then

                If IFileOperation.SetOperationFlags(flags) = True Then

                    If IFileOperation.NewItem(pDstIShellItem, dwFileAttributes, _
                        szName, szTemplateName, pIOps) = True Then

                        If Not IOpd Is Nothing Then Call IOpd.StartProgressDialog( _
                            hwndOwner, IOpdFlags)

                        If IFileOperation.PerformOperations = True Then

                            If IFileOperation.GetAnyOperationAborted = False Then

                                bRet = True

                            End If

                        End If

                        If Not IOpd Is Nothing Then Call IOpd.StopProgressDialog

                    End If

                End If

            End If

            If lCookie <> 0& Then

                Call IFileOperation.Unadvise(lCookie)

            End If

            Set IFileOperation = Nothing

            Set IShellItemDst = Nothing

        End If

        Call CoTaskMemFree(lDstPIDL)

    End If

    NewItem = bRet

End Function

' ----==== Helper Func ====----
'
' liefert den Item-Identifier (PIDL) einer Datei oder eines Ordners
Private Function GetPIDLFromPath(ByVal sPath As String) As Long

    Dim lRet As Long
    Dim lPIDL As Long
    Dim pIShellFolder As Long
    Dim IShellFolder As clsIShellFolder

    ' nur wenn der Ordner oder die Datei existiert
    If DirFileExists(sPath) = True Then

        ' IShellFolder des Desktops holen
        If SHGetDesktopFolder(pIShellFolder) = S_OK Then

            ' IShellFolder initialisieren
            Set IShellFolder = New clsIShellFolder
            Call IShellFolder.Init(pIShellFolder)

            ' PIDL einer Datei oder eines Ordners ermitteln
            lPIDL = IShellFolder.ParseDisplayName(sPath)

            If lPIDL <> 0& Then

                lRet = lPIDL

            End If

            ' aufrumen
            Set IShellFolder = Nothing

        End If

    End If

    GetPIDLFromPath = lRet

End Function

Public Function ShItemInfo(ByVal pIShellItem As Long) As String

    ' clsRetIShellItem ruft kein ReleaseInterface bei "Set IShellItem = Nothing"
    ' auf. Sonst bricht der Vorgang (Kopieren, Verschieben usw) ab!!!

    Dim sRet As String
    Dim IShellItem As clsRetIShellItem

    ' ist ein Pointer auf ein IShellItem Interface vorhanden
    If pIShellItem <> 0& Then

        ' IShellItem Interface initialisieren
        Set IShellItem = New clsRetIShellItem
        Call IShellItem.Init(pIShellItem)

        ' FILESYSPATH vom IShellItem ermitteln
        sRet = IShellItem.GetDisplayName(SIGDN_FILESYSPATH)

        ' Aufrumen
        Set IShellItem = Nothing

    End If

    ShItemInfo = sRet

End Function

' kompletten Pfad erstellen
Private Function CreatePath(ByVal sPath As String) As Boolean

    If Right$(sPath, 1) <> "\" Then sPath = sPath & "\"

    If MakePath(sPath) = 1 Then

        CreatePath = True

    Else

        CreatePath = False

    End If

End Function

Private Function DirFileExists(ByVal sDirFileName As String) As Boolean

    If FileExists(sDirFileName) = True Or DirExists(sDirFileName) = True Then

        DirFileExists = True

    Else

        DirFileExists = False

    End If

End Function

' ist eine Datei vorhanden
Private Function FileExists(ByVal sFileName As String) As Boolean

    Dim dwAttributes As Long

    dwAttributes = GetFileAttributes(sFileName)

    If dwAttributes = INVALID_FILE_ATTRIBUTES Then

        FileExists = False

    ElseIf CBool(dwAttributes And FileAttributes.FILE_ATTRIBUTE_DIRECTORY) Then

        FileExists = False

    Else

        FileExists = True

    End If

End Function

' ist ein Ordner vorhanden
Private Function DirExists(ByVal sDirectoryName As String) As Boolean

    Dim dwAttributes As Long

    If Right$(sDirectoryName, 1) <> "\" Then sDirectoryName = sDirectoryName & "\"

    dwAttributes = GetFileAttributes(sDirectoryName)

    If dwAttributes = INVALID_FILE_ATTRIBUTES Then

        DirExists = False

    ElseIf CBool(dwAttributes And FileAttributes.FILE_ATTRIBUTE_DIRECTORY) Then

        DirExists = True

    Else

        DirExists = False

    End If

End Function

' ----==== StrPtr to String ====----
Public Function Ptr2Str(ByVal lpStrPtr As Long) As String

    Dim lLen As Long
    Dim bBuffer() As Byte

    lLen = lstrlenW(lpStrPtr) * 2 - 1

    If lLen > 0 Then

        ReDim bBuffer(lLen)

        Call RtlMoveMemory(bBuffer(0), ByVal lpStrPtr, lLen)

        Call CoTaskMemFree(lpStrPtr)

        Ptr2Str = bBuffer

    End If

End Function

' ----==== GUID to String ====----
Public Function Guid2String(ByRef tguid As GUID) As String

    Dim lGuid As Long

    Call StringFromCLSID(tguid, lGuid)

    Guid2String = Ptr2Str(lGuid)

End Function

' ----==== ULongLong to Currency ====----
Public Function ULoLo2Cur(ByRef tULONGLONG As ULONGLONG) As Currency

    Call RtlMoveMemory(ULoLo2Cur, tULONGLONG, 8)

End Function

' ----==== Milliseconds to Time (String) ====----
Public Function ConvertMStoTime(ByVal CurValue As Currency) As String

    Dim minutes As Long
    Dim seconds As Long
    Dim milliseconds As Long

    CurValue = CurValue * 10000

    minutes = (CurValue / 1000) \ 60
    seconds = (CurValue \ 1000) Mod 60
    milliseconds = CurValue Mod 1000

    ConvertMStoTime = Format$(minutes, "00") & ":" & Format$(seconds, "00") & _
        ":" & Format$(milliseconds, "000")

End Function


